<?php

namespace NoccyLabs\TreeDumper;

class TreeDumperTest extends \PhpUnit_Framework_TestCase
{

    protected $dumper;

    public function setup()
    {
        $this->dumper = new TreeDumper();
    }

    public function teardown()
    {
    }

    public function testAsciiTree()
    {
        $this->dumper->setStyle("ascii");
        $input = array("Hello" => array("World"));
        $expect = "Hello\n +--World\n";
        $output = $this->dumper->dump($input,true);
        $this->assertEquals($output, $expect);
    }

    public function testUtf8Tree()
    {
        $this->dumper->setStyle("utf8");
        $input = array("Hello" => array("World"));
        $expect = $this->uchars("Hello\n \u2514\u2500\u2500World\n");
        $output = $this->dumper->dump($input,true);
        $this->assertEquals($output, $expect);
    }

    protected function uchars($str)
    {
        return preg_replace_callback("/\\\\u([0-9a-fA-F]{1,4})?/", function ($tok) {
            return html_entity_decode("&#x{$tok[1]};",ENT_COMPAT,"UTF-8");
        }, $str);
    }

}

